# A2Soft CLI

CLI для ускоренной инициализации проекта. Создан поверх библиотеки [mason](https://pub.dev/packages/mason)

## Установка 💽
Для глобальной установки нужно выполнить следующую команду:
```sh
dart pub global activate cli_a2soft
```

## Доступные команды 📋

### `a2_cli create`

Создает проект с базовым темплейтом и возможностью выборочного подключения модулей (например, можно подключить локализацию или базу данных).

### `a2_cli bloc`

Создает BLoC с базовыми состояниями по указанному пути.

### `a2_cli --help`

Просмотр списка доступных команд.

## Работа с модулями (Brick'ами) 📦

Для работы (создания, редактирования) с модулями необходимо глобально установить на свое устройство библиотеку [mason_cli](https://pub.dev/packages/mason_cli)

## Как отредактировать существующий модуль (Brick)? 🔨

Существующие модули находятся в корневой папке './bricks'. После внесения изменений необходимо сгенерировать новый dart bundle и положить его в папку './lib/bricks'.

Сделать это можно с помощью следующей команды:
```sh
mason bundle ./bricks/название_модуля -t dart -o ./lib/bricks/название_модуля
```

## Как создать новый модуль (Brick)? 🏗

Для создания нового модуля необходимо выполнить следующую команду:
```sh
mason new название_модуля
```

После создания модуля для последующей его интеграции генерируем bundle с помощью следующей команды:
```sh
mason bundle ./bricks/название_модуля -t dart -o ./lib/bricks/название_модуля
```
Далее можно сгенерировать код с помощью функции generateBundle из миксина CLIMixin.
