import 'package:dio/dio.dart';
import 'package:flutter_dotenv/flutter_dotenv.dart';
import 'package:flutter_simple_dependency_injection/injector.dart';
{{#is_database}}import 'package:{{#snakeCase}}{{project_name}}{{/snakeCase}}/database/db.dart';{{/is_database}}

import 'app_config.dart';

/// Вспомогательный класс для внедрения зависимостей
class ModulesInjectorHelper {
  /// Внедрение зависимостей через инжектор [injector]
  Future<void> inject(Injector injector) async {
    final dio = await _initDioWithConfig();
    final baseURL = AppConfig.baseURL;
    injector.map<Dio>((i) => dio, isSingleton: true);
    {{#is_database}}
    final db = DB();
    injector.map<DB>((i) => db, isSingleton: true);
    {{/is_database}}
  }

  /// Возвращает сконфигурированный dio-клиент
  Future<Dio> _initDioWithConfig() async {
    final dio = Dio();
    await _setDioHeaders(dio);
    dio.options.connectTimeout = 10000;
    dio.interceptors.addAll([]);
    return dio;
  }

  /// Проставить нужные хедеры в dio-клиент
  Future<void> _setDioHeaders(Dio dio) async {}
}
