import 'package:{{#snakeCase}}{{project_name}}{{/snakeCase}}/router/router.dart';
import 'package:{{#snakeCase}}{{project_name}}{{/snakeCase}}/styles/themes.dart';
import 'package:{{#snakeCase}}{{project_name}}{{/snakeCase}}/helpers/modules_injector_helper.dart';
import 'package:{{#snakeCase}}{{project_name}}{{/snakeCase}}/helpers/custom_scroll_behavior.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:flutter_dotenv/flutter_dotenv.dart';
import 'package:flutter_simple_dependency_injection/injector.dart';
import 'package:provider/provider.dart';
{{#is_localization}}import 'package:flutter_localizations/flutter_localizations.dart';{{/is_localization}}
{{#is_localization}}import 'package:{{#snakeCase}}{{project_name}}{{/snakeCase}}/i18n/strings.g.dart';{{/is_localization}}

void main() async {
  {{#is_localization}}
  WidgetsFlutterBinding.ensureInitialized();
  LocaleSettings.useDeviceLocale();
  {{/is_localization}}  {{^is_localization}}WidgetsFlutterBinding.ensureInitialized();{{/is_localization}}
  await dotenv.load(fileName: ".properties");
  SystemChrome.setSystemUIOverlayStyle(const SystemUiOverlayStyle(
    statusBarColor: Colors.transparent,
    systemNavigationBarColor: Colors.black,
    statusBarBrightness: Brightness.dark,
    statusBarIconBrightness: Brightness.dark,
    systemNavigationBarIconBrightness: Brightness.dark,
  ));
  await ModulesInjectorHelper().inject(Injector());
  runApp(
    {{#is_localization}}TranslationProvider(child:{{/is_localization}}
    Provider(
      create: (context) => AppTheme(context),
      child: const AnnotatedRegion(
        child: MyApp(),
        value: SystemUiOverlayStyle.dark,
      ),
    {{#is_localization}}),{{/is_localization}}
    ),
  );
}

class MyApp extends StatefulWidget {
  const MyApp({Key? key}) : super(key: key);

  @override
  State<MyApp> createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  final _appRouter = AppRouter();
  @override
  Widget build(BuildContext context) {
    AppTheme theme = context.read<AppTheme>();

    return MaterialApp.router(
      routerDelegate: _appRouter.delegate(),
      routeInformationParser: _appRouter.defaultRouteParser(),
      scrollBehavior: CustomScrollBehavior(),
      {{#is_localization}}locale: TranslationProvider.of(context).flutterLocale,
      supportedLocales: LocaleSettings.supportedLocales,
      localizationsDelegates: GlobalMaterialLocalizations.delegates,{{/is_localization}}
      debugShowCheckedModeBanner: false,
      title: "{{#titleCase}}{{project_name}}{{/titleCase}}",
    );
  }
}
