import 'package:dio/dio.dart';
import 'package:either_dart/either.dart';
import 'package:{{#snakeCase}}{{project_name}}{{/snakeCase}}/services/sample_api_client.dart';
import 'package:{{#snakeCase}}{{project_name}}{{/snakeCase}}/models/api/error_item_response.dart';
import 'package:{{#snakeCase}}{{project_name}}{{/snakeCase}}/models/api/success_item_response.dart';

/// Репозиторий sample-раздела
class SampleRepository {
  /// Апи клиент с методами catalog-раздела
  final SampleApiClient _apiClient;

  SampleRepository(this._apiClient);

  /// Получение
  Future<Either<ErrorItemResponse, SuccessItemResponse>> getSamples() async {
    try {
      final response = await _apiClient.getSamples();
      return Right(response);
    } on DioError catch (error) {
      return Left(ErrorItemResponse.fromJson(error.response?.data));
    }
  }
}
