import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

/// Базовый класс цветовой темы приложения
/// [_context] - [BuildContext] приложения, нужен для определения
/// какие цвета предоставлять (для светлой или темной темы)
class AppColors {
  final BuildContext _context;

  AppColors(this._context);

  /// Белый
  Color get whiteMainColor {
    return CupertinoDynamicColor.resolve(
      const CupertinoDynamicColor.withBrightness(
        color: Colors.white,
        darkColor: Colors.white,
      ),
      _context,
    );
  }

  /// Черный
  Color get blackMainColor {
    return CupertinoDynamicColor.resolve(
      const CupertinoDynamicColor.withBrightness(
        color: Colors.black,
        darkColor: Colors.white,
      ),
      _context,
    );
  }
}
