import 'dart:io';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter/foundation.dart' show kIsWeb;

import 'colors.dart';

/// Базовый класс стилей текстов приложения
/// [_textStyle] - базовый стиль текста приложения
class AppTextStyles {
  final TextStyle _textStyle;

  AppTextStyles(BuildContext context, AppColors appColors)
      : _textStyle = CupertinoTheme.of(context).textTheme.textStyle.copyWith(
            letterSpacing: !kIsWeb
                ? Platform.isAndroid
                    ? 0.3
                    : null
                : null);

  /// Большой заголовок
  TextStyle get title1 => _textStyle.copyWith(
        color: Colors.black,
        fontSize: 24,
        fontWeight: FontWeight.w600,
      );
}
