import 'package:flutter/material.dart';
import 'package:provider/provider.dart';
import 'package:{{#snakeCase}}{{project_name}}{{/snakeCase}}/styles/themes.dart';

/// Базовый класс страницы
abstract class BaseView extends StatefulWidget {
  const BaseView({Key? key}) : super(key: key);
}

/// Базовый класс State'а страницы
abstract class BaseState<View extends BaseView> extends State<View> {}

/// Миксин, добавляющий базовые компоненты страницы
mixin BasePage<View extends BaseView> on BaseState<View> {
  @override
  Widget build(BuildContext context) {
    AppTheme theme = context.read<AppTheme>();

    return GestureDetector(
      behavior: HitTestBehavior.opaque,
      onTap: () => FocusScope.of(context).unfocus(),
      child: Scaffold(
        appBar: appBar(),
        backgroundColor: backgroundColor() ?? theme.colors.whiteMainColor,
        body: SizedBox(
          width: double.infinity,
          child: body(),
        ),
      ),
    );
  }

  /// Тело страницы
  Widget body();

  /// Заголовок страницы в Scaffold
  PreferredSizeWidget? appBar() => null;

  /// Цвет заднего фона
  Color? backgroundColor() => null;
}
