import 'dart:async';

import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:{{#snakeCase}}{{project_name}}{{/snakeCase}}/models/common/base_error_state.dart';
import 'package:{{#snakeCase}}{{project_name}}{{/snakeCase}}/views/base_views/base_view.dart';

/// Миксин с обработкой ошибок
mixin ErrorHandlingMixin<View extends BaseView, Bloc extends BlocBase> on BaseState<View> {
  /// Подписка на события Bloc'а
  late final StreamSubscription<dynamic> subscription;

  /// Показ ошибки
  void showError(String errorMessage) {
    print(errorMessage);
  }

  @override
  void initState() {
    // Подписка на события и проверка на ошибочный стейт
    final bloc = context.read<Bloc>();
    subscription = bloc.stream.listen((state) {
      if (state is BaseErrorState) {
        showError(state.message);
      }
    });
    super.initState();
  }

  @override
  void dispose() {
    // Отписка от событий
    subscription.cancel();
    super.dispose();
  }
}
