import 'package:drift/native.dart';
import 'package:path_provider/path_provider.dart';
import 'package:path/path.dart' as p;
import 'package:drift/drift.dart';
import 'dart:io';

part 'db.g.dart';

LazyDatabase _openConnection() {
  return LazyDatabase(() async {
    final dbFolder = await getApplicationDocumentsDirectory();
    final file = File(p.join(dbFolder.path, '{{project_name}}.sqlite'));
    return NativeDatabase(file);
  });
}

/// Локальная база данных приложения
@DriftDatabase(tables: [])
class DB extends _$DB {
  DB() : super(_openConnection());
  @override
  int get schemaVersion => 1;
}
